'----------------------------------------------------------------'
'Project Name  : Frequency 9Khz                                  '
'Xtal External : 8Mhz                                            '
'MCU           : PIC16F628A                                      '
'Code By       : Sagor                                           '
'Test By       : Mini                                            '
'Forum         : https://www.electro-tech-online.com/threads/how-to-produce-a-frequency-in-khz.154429/ '
'Test Result   :
'TMR0 145 =  7874Hz                                              '
'TMR0 161 =  9091Hz                                              '
'----------------------------------------------------------------'

Define CONFIG = 0x3f0a  '16f628a
'Example of 18Khz interrupt to produce 9Khz output
'actual Output is 9009Hz due To rounding errors/accuracy with 8Mhz
'actual output is 8992Hz due to rounding errors at 20Mhz

'Use 8Mhz crystal
Define CLOCK_FREQUENCY = 8.0  '8 Mhz

'Use 20 Mhz crystal
'Define CLOCK_FREQUENCY = 20.0

TRISA.0 = 0
PORTA.0 = 1
'WaitMs 350                   'Test for blink, if the value delay is added then frequency going to lower for some Hz
'PORTA.0 = 0
'WaitMs 350
'PORTA.0 = 1

'Example using timer0 to set 55.5us interrupt
'for 8Mhz crystal
OPTION_REG = 0x88
'WaitMs 50

'ASM:        nop

TMR0 = 161  '145 Original Frequency 7874 Hz
INTCON = 0xa0  'enable interrupts and timer0 interrupt

'for 20Mhz crystal:
'OPTION_REG = 0x80
'TMR0 = 117
'INTCON = 0xa0  'enable interrupts and timer0 interrupt

'ASM:        nop

Enable  'Enable interrupts
loop:
'main code here
Goto loop
End                                               

'Interrupt routine with 8Mhz takes about 9us to complete without "Save System"
'Takes about 12.5us with Save System
'With 20Mhz crystal, total time will be 5uS with Save System

'ASM:        nop

On Interrupt
Save System
If INTCON.T0IF = 1 Then
INTCON.T0IF = 0
ASM:        nop
'For 8Mhz crystal
TMR0 = 161  '145 Original Frequency 7,874 Hz

'For 20Mhz crystal, reset to 20Mhz count:
'TMR0 = 117

'Enter your interrupt code here
Toggle PORTB.0  'Output signal here
Endif
Resume                                            
